## ros-indigo-diff-drive-controller 0.9.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(diff_drive_controller)

find_package(catkin REQUIRED COMPONENTS
    controller_interface
    urdf
    realtime_tools
    tf
    nav_msgs)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
)

include_directories(
  include ${catkin_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME} src/diff_drive_controller.cpp src/odometry.cpp src/speed_limiter.cpp)
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES})

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

install(FILES diff_drive_controller_plugins.xml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

if (CATKIN_ENABLE_TESTING)
  find_package(catkin COMPONENTS rostest std_srvs controller_manager tf)
  include_directories(include ${catkin_INCLUDE_DIRS})

  add_executable(diffbot test/diffbot.cpp)
  target_link_libraries(diffbot ${catkin_LIBRARIES})

  add_executable(skidsteerbot test/skidsteerbot.cpp)
  target_link_libraries(skidsteerbot ${catkin_LIBRARIES})

  add_dependencies(tests diffbot skidsteerbot)

  add_rostest_gtest(diff_drive_test
    test/diff_drive_controller.test
    test/diff_drive_test.cpp)
  target_link_libraries(diff_drive_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_nan_test
    test/diff_drive_controller_nan.test
    test/diff_drive_nan_test.cpp)
  target_link_libraries(diff_drive_nan_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_limits_test
    test/diff_drive_controller_limits.test
    test/diff_drive_limits_test.cpp)
  target_link_libraries(diff_drive_limits_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_timeout_test
    test/diff_drive_timeout.test
    test/diff_drive_timeout_test.cpp)
  target_link_libraries(diff_drive_timeout_test ${catkin_LIBRARIES})
  add_rostest(test/diff_drive_multipliers.test)
  add_rostest_gtest(diff_drive_fail_test
    test/diff_drive_wrong.test
    test/diff_drive_fail_test.cpp)
  target_link_libraries(diff_drive_fail_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_odom_tf_test
    test/diff_drive_odom_tf.test
    test/diff_drive_odom_tf_test.cpp)
  target_link_libraries(diff_drive_odom_tf_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_default_odom_frame_test
    test/diff_drive_default_odom_frame.test
    test/diff_drive_default_odom_frame_test.cpp)
  target_link_libraries(diff_drive_default_odom_frame_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_odom_frame_test
    test/diff_drive_odom_frame.test
    test/diff_drive_odom_frame_test.cpp)
  target_link_libraries(diff_drive_odom_frame_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_default_cmd_vel_out_test
    test/diff_drive_default_cmd_vel_out.test
    test/diff_drive_default_cmd_vel_out_test.cpp)
  target_link_libraries(diff_drive_default_cmd_vel_out_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_pub_cmd_vel_out_test
    test/diff_drive_pub_cmd_vel_out.test
    test/diff_drive_pub_cmd_vel_out_test.cpp)
  target_link_libraries(diff_drive_pub_cmd_vel_out_test ${catkin_LIBRARIES})
  add_rostest(test/diff_drive_open_loop.test)
  add_rostest(test/skid_steer_controller.test)
  add_rostest(test/skid_steer_no_wheels.test)
  add_rostest(test/diff_drive_radius_param.test)
  add_rostest(test/diff_drive_radius_param_fail.test)
  add_rostest(test/diff_drive_separation_param.test)
  add_rostest(test/diff_drive_bad_urdf.test)
endif()

=== debian/changelog ===
ros-indigo-diff-drive-controller (0.9.4-0trusty) trusty; urgency=high

  * Publish executed velocity if publish_cmd
  * Contributors: Bence Magyar, Jeremie Deray

 -- Bence Magyar <bence.magyar@pal-robotics.com>  Fri, 30 Jun 2017 23:00:00 -0000

ros-indigo-diff-drive-controller (0.9.3-0trusty) trusty; urgency=high

  * Reduced pedantry, redundancy.
  * Added tests for the odom_frame_id parameter.
  * Parameterized diff_drive_controller's odom_frame_id
  * add check for multiple publishers on cmd_vel
  * Address -Wunused-parameter warnings
  * Limit jerk
  * Add param velocity_rolling_window_size
  * Minor fixes
    1. Coding style
    2. Tolerance to fall-back to Runge-Kutta 2 integration
    3. Remove unused variables
  * Fix forward test
    Fix the following bugs in the testForward test:
    1. Check traveled distance in XY plane
    2. Use expected speed variable on test check
  * Add test for NaN
  * Add test for bad URDF
    This unit test exercises a controller load failure caused by
    a wrong wheel geometry. The controller requires that wheels be
    modeled by cylinders, while the bad URDF uses spheres.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Bence Magyar, Enrique Fernandez, Eric Tappan, Karsten Knese, Paul Mathieu, tappan-at-git

 -- Bence Magyar <bence.magyar@pal-robotics.com>  Fri, 12 Feb 2016 00:00:00 -0000

ros-indigo-diff-drive-controller (0.9.2-0trusty) trusty; urgency=high

  * Allow the wheel separation and radius to be set from different sources
    i.e. one can be set from the URDF, the other from the parameter server.
    If wheel separation and wheel diameter is specified in the parameter server, don't look them up from urdf
  * Contributors: Bence Magyar, Nils Berg

 -- Bence Magyar <bence.magyar@pal-robotics.com>  Sun, 03 May 2015 23:00:00 -0000

ros-indigo-diff-drive-controller (0.9.1-0trusty) trusty; urgency=high



 -- Bence Magyar <bence.magyar@pal-robotics.com>  Mon, 03 Nov 2014 00:00:00 -0000

ros-indigo-diff-drive-controller (0.9.0-0trusty) trusty; urgency=high

  * Add support for multiple wheels per side
  * Odometry computation:
    - New option to compute in open loop fashion
    - New option to skip publishing odom frame to tf
  * Remove dependency on angles package
  * Buildsystem fixes
  * Contributors: Bence Magyar, Lukas Bulwahn, efernandez

 -- Bence Magyar <bence.magyar@pal-robotics.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-indigo-diff-drive-controller (0.8.1-0trusty) trusty; urgency=high



 -- Bence Magyar <bence.magyar@pal-robotics.com>  Thu, 10 Jul 2014 23:00:00 -0000

ros-indigo-diff-drive-controller (0.8.0-0trusty) trusty; urgency=high

  * Add base_frame_id param (defaults to base_link)
    The nav_msgs/Odometry message specifies the child_frame_id field,
    which was previously not set.
    This commit creates a parameter to replace the previously hard-coded
    value of the child_frame_id of the published tf frame, and uses it
    in the odom message as well.
  * Contributors: enriquefernandez

 -- Bence Magyar <bence.magyar@pal-robotics.com>  Sun, 11 May 2014 23:00:00 -0000

ros-indigo-diff-drive-controller (0.7.2-0trusty) trusty; urgency=high



 -- Bence Magyar <bence.magyar@pal-robotics.com>  Mon, 31 Mar 2014 23:00:00 -0000

ros-indigo-diff-drive-controller (0.7.1-0trusty) trusty; urgency=high

  * Changed test-depend to build-depend for release jobs.
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar@pal-robotics.com>  Sun, 30 Mar 2014 23:00:00 -0000

ros-indigo-diff-drive-controller (0.7.0-0trusty) trusty; urgency=high

  * diff_drive_controller: New controller for differential drive wheel systems.
  * Control is in the form of a velocity command, that is split then sent on the two wheels of a differential drive
  wheel base.
  * Odometry is published to tf and to a dedicated nav__msgs/Odometry topic.
  * Realtime-safe implementation.
  * Implements task-space velocity and acceleration limits.
  * Automatic stop after command time-out.
  * Contributors: Bence Magyar, Paul Mathieu, Enrique Fernandez.

 -- Bence Magyar <bence.magyar@pal-robotics.com>  Fri, 28 Mar 2014 00:00:00 -0000

=== debian/control ===
Source: ros-indigo-diff-drive-controller
Section: misc
Priority: extra
Maintainer: Bence Magyar <bence.magyar@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-controller-interface, ros-indigo-controller-manager, ros-indigo-nav-msgs, ros-indigo-realtime-tools, ros-indigo-rostest, ros-indigo-std-srvs, ros-indigo-tf, ros-indigo-urdf, ros-indigo-xacro
Homepage: https://github.com/ros-controls/ros_controllers/wiki
Standards-Version: 3.9.2

Package: ros-indigo-diff-drive-controller
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-controller-interface, ros-indigo-nav-msgs, ros-indigo-realtime-tools, ros-indigo-tf, ros-indigo-urdf
Description: Controller for a differential drive mobile base.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-diff-drive-controller//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
